;; bship-client.scm
;;; battleship client -- more SocketMan magic

(load "bship")
(define *bship-port* 8001)


;;; create the client
(define client (new-SocketClient *bship-port*))

;;; get the server name
(define (read-loop)
  (display "Enter the server name IN DOUBLE QUOTES: ")
  (let ((response (read)))
    (if (not (string? response))
	(begin
	  (display "Please enter the name of the server IN DOUBLE QUOTES.\n")
	  (read-loop))
	response)))

;;; loop used for trying to connect to a server
(define (connect-to-server-loop)
  (let ((the-response (send client 'connectToServer server-name)))
    (if (not (= SocketMan::MSG_NO_ERROR the-response))
	(begin
	  (socketman-print-error the-response)
	  (if (= SocketMan::ERR_UNKNOWN_HOST the-response)
	      (set! server-name (read-loop)))
	  (connect-to-server-loop)))))

(define server-name (read-loop))

(display "Connecting to server...hit CTRL-C to abort.\n")


;;; wait until connection is established
(connect-to-server-loop)


;;; methods for network activity for client
(define (send-over-network object)
  (write-object-to-network object client))

(define (get-from-network)
  (read-object-from-network client))
